#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <cxcore.h>
#include <cv.h>
#include "highgui.h"
#include "../main/func_extern.h"
//#include "num_detect_extern.h"

//STANDERD VALUES
#define HIGH	255
#define LOW		0
//PARAM (MAIN)
#define SLEEP_TIME	10//msec
#define IMAGE_WIDTH		320
#define IMAGE_HEIGHT	240

#define EXIT_DIS 50


int exit_detect(char c){
	IplImage	*inputImage = NULL,
				*Image=NULL,
				*grayImage = NULL,
				*work = NULL,
				*gray = NULL;
	int exit_det;
	int i,j;
	char *filename = "input.jpg";
	img_update(filename, IMAGE_WIDTH, IMAGE_HEIGHT);
	if(inputImage != NULL) {cvReleaseImage(&inputImage);
	}else{//変数とかの初期化
				inputImage = cvCreateImage(cvSize(IMAGE_WIDTH, IMAGE_HEIGHT), IPL_DEPTH_8U, 3);
	}
	inputImage = cvLoadImage(filename, CV_LOAD_IMAGE_ANYCOLOR);
	switch(c){
		case 'r':

			Image = cvCreateImage( cvSize(320,30),IPL_DEPTH_8U, 3);
			triming1(inputImage,Image,cvRect(0,110,320,30));
			grayImage = cvCreateImage(cvGetSize(Image), IPL_DEPTH_8U, 1);
			gray = cvCreateImage(cvGetSize(Image), IPL_DEPTH_8U, 1);
			//エッジ抽出
			cvCvtColor(Image, grayImage, CV_BGR2GRAY);
			cvThreshold(grayImage, gray, 60, HIGH, CV_THRESH_BINARY_INV | CV_THRESH_OTSU);
			//exit_noisecut(gray);
			//出口検出
			select_exit(gray,&j);
			//printf("exit=%d\n",j);
			exit_det=j;

		break;

	case 'c'://小部屋

		//IplImage	*Image = NULL;
		Image = cvCreateImage( cvSize(320,50),IPL_DEPTH_8U, 3);
		triming1(inputImage,Image,cvRect(0,95,320,50));
		grayImage = cvCreateImage(cvGetSize(Image), IPL_DEPTH_8U, 1);
		gray = cvCreateImage(cvGetSize(Image), IPL_DEPTH_8U, 1);
		//エッジ抽出
		cvCvtColor(Image, grayImage, CV_BGR2GRAY);
		cvThreshold(grayImage, gray, 60, HIGH, CV_THRESH_BINARY_INV /*| CV_THRESH_OTSU*/);
		exit_noisecut(gray);
		//出口検出
		select_val(gray,&j);
		//printf("exit=%d\n",j);

		exit_det=j;
		cvSaveImage("./image/lmage.jpg",Image,0);

		break;
	case 'k'://小部屋

			//IplImage	*Image = NULL;
			Image = cvCreateImage( cvSize(320,30),IPL_DEPTH_8U, 3);
			triming1(inputImage,Image,cvRect(0,100,320,30));
			grayImage = cvCreateImage(cvGetSize(Image), IPL_DEPTH_8U, 1);
			gray = cvCreateImage(cvGetSize(Image), IPL_DEPTH_8U, 1);
			work = cvCreateImage(cvGetSize(Image), IPL_DEPTH_8U, 1);
			//エッジ抽出
			cvCvtColor(Image, grayImage, CV_BGR2GRAY);
			cvThreshold(grayImage, gray, 50, HIGH, CV_THRESH_BINARY_INV /*| CV_THRESH_OTSU*/);
			exit_noisecut(gray);

			CvMemStorage* storage = cvCreateMemStorage(0);
			CvMemStorage* storage1 = cvCreateMemStorage(0);
		        CvSeq *lines = 0;
			CvSeq *lines1  = 0;
			CvPoint *point, pt1, pt2,pt3;
			double a, b, x0, y0;
			float *line, rho, theta;
			lines1 = cvHoughLines2 ( gray, storage1, CV_HOUGH_STANDARD, 1, CV_PI / 180,1, 0, 0);
			for (i = 0; i < MIN (lines1->total, 100); i++) {
		    	line = (float *) cvGetSeqElem (lines1, i);
		    	rho = line[0];
		    	theta = line[1];
		    	a = cos (theta);
		    	b = sin (theta);
		    	x0 = a * rho;
		    	y0 = b * rho;
		    	pt1.x = cvRound (x0 + 1000 * (-b));
		    	pt1.y = cvRound (y0 + 1000 * (a));
		    	pt2.x = cvRound (x0 - 1000 * (-b));
		  	pt2.y = cvRound (y0 - 1000 * (a));
		  	if(a>=0.99 || a <= -0.99 ){
		   	cvLine(work, pt1, pt2, CV_RGB (255,255,255), 1, 8, 0);
			}
			}
			//出口検出
			if(exit_val(work,&j)==-1){j=0;}
			//printf("exit=%d\n",j);

			exit_det=j;
			cvSaveImage("./image/work.jpg",work,0);
			cvReleaseImage(&work);
			break;
	}
	cvSaveImage("./image/lmage.jpg",Image,0);
	cvSaveImage("./image/capture.jpg",inputImage,0);
	cvSaveImage("./image/threshold.jpg",gray,0);
	cvReleaseImage(&inputImage);
	cvReleaseImage(&grayImage);
	cvReleaseImage(&gray);
	cvReleaseImage(&Image);
	return exit_det;
}


