/*
 * introduction.c
 *
 *  Created on: 2013/01/21
 *      Author: d09101
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <errno.h>
#include "func_extern.h"
#include "motor.h"
#include "control.h"

#define  ESC    0x1B
#define  WAIT   10000000  /* 待ち時間 */
#define  LOOP   200             /* 繰り返し回数 */


extern int f_ts_flag;
extern int ts_exit_flag;
extern float sp_time;
extern int timer_exit_flag;

extern char word[50];

void introduction1(void){
	int    xpos, ypos = 8;   /* x, y 座標 */
	int    i = 0;
	long   j;

	printf("%c[2J", ESC);    /* 画面消去 */
	printf("%c[>5h", ESC);   /* カーソル消去 */
	printf("%c[33m", ESC);   /* 文字を黄色に */


	while(f_ts_flag!=1){
	    xpos = i % 80 + 1;
	    if (xpos == 1)    ypos++;
	    /* 腕を上げる */
	    printf("%c[%d;%dH  Yo¥¥oY", ESC, ypos,   xpos);
	    printf("%c[%d;%dH    w   ", ESC, ypos+1, xpos);
	    printf("%c[%d;%dH   | |  ", ESC, ypos+2, xpos);
	    for (j=0; j<WAIT; j++) { }
	    /* 腕を下げる */
	    printf("%c[%d;%dH   o¥¥o ", ESC, ypos,   xpos+1);
	    printf("%c[%d;%dH >- w -<", ESC, ypos+1, xpos+1);
	    printf("%c[%d;%dH   < >  ", ESC, ypos+2, xpos+1);
	    for (j=0; j<WAIT; j++) { }
	}
	printf("%c[>5l", ESC);  /* カーソル表示 */
	printf("%c[39m", ESC);  /* 文字色を戻す */

	sprintf((char*)word,"haxtushin/shima'_su.");
	talk(word);
	ts_exit_flag=1;
	pthread_exit(0);
	return ;
}

void introduction2(void){
	sprintf((char*)word,"huxtu kaaaaa'_tsu");
	talk(word);
	sleep(2);
	sprintf((char*)word,"soukoukaishima'de");
	talk(word);
	sleep(2);
	sprintf((char*)word,"sanbyoo'mae");
	talk(word);
	while((int)sp_time <=6){
		if(f_ts_flag==1)exit(-1);
		usleep(100);
	}
	sprintf((char*)word,"ni'i");
	talk(word);
	while((int)sp_time <= 7){
		if(f_ts_flag==1)exit(-1);
		usleep(100);
	}
	sprintf((char*)word,"i'chi");
	talk(word);
	while((int)sp_time <= 8){
		if(f_ts_flag==1)exit(-1);
		usleep(100);
	}
	sprintf((char*)word,"haxtu/shinshima'_su.");
	talk(word);
	ts_exit_flag=1;
	timer_exit_flag=1;
	pthread_exit(0);
	return ;
}
