#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <errno.h>
#include "func_extern.h"
#include "motor.h"
#include "control.h"


extern int r_uss_wall_flag;
extern int r_uss_wall_ap_flag;
extern int l_uss_wall_flag;
extern int l_uss_wall_ap_flag;
extern int const_flag;

extern int kobeya_state;

extern int step;

void kobeya_control(void){
	int kobeya_param[5],front_uss[2],dir;
	switch(step){
		case 1:
			if(kobeya_state==1||kobeya_state==3){
				kobeya_param[0]=200;
				kobeya_param[1]=30;
				kobeya_param[4]=0;
			}else{
				kobeya_param[0]=100;
				kobeya_param[1]=30;
				kobeya_param[4]=0;
			}
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);;
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			pthread_join(uss_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			if(const_flag==1)step=2;
			break;
		case 2:
			kobeya_param[0]=500;
			kobeya_param[1]=4000;
			kobeya_param[4]=0;
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
			pthread_create(&uss_task,&attr_uss,uss_thread,30);
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			pthread_join(uss_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			if(const_flag==1){
				step=6;
				if(r_uss_wall_flag==0)step=14;
				if(l_uss_wall_flag==0)step=16;
				if(r_uss_wall_ap_flag==0)step=4;
				if(l_uss_wall_ap_flag==0)step=5;
			}
			break;
		case 4:
			kobeya_param[0]=-500;
			kobeya_param[1]=4000;
			kobeya_param[4]=0;
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
			pthread_create(&uss_task,&attr_uss,uss_thread,30);
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			pthread_join(uss_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			if(const_flag==1)step=14;
			break;
		case 5:
			kobeya_param[0]=-500;
			kobeya_param[1]=4000;
			kobeya_param[4]=0;
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
			pthread_create(&uss_task,&attr_uss,uss_thread,30);
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			pthread_join(uss_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			if(const_flag==1)step=16;
			break;
		case 6:
			front_uss[0]=uss_get(1);
			front_uss[1]=uss_get(2);
			if(front_uss[0] > 30 && front_uss[1] > 30)step=18;
			switch(kobeya_state){
				case 1:
					dir=1;
					step=7;
					break;
				case 2:
					step=10;
					break;
				case 3:
					dir=-1;
					step=7;
					break;
			}
			break;
		case 7:
			kobeya_param[0]=90*dir;
			kobeya_param[1]=800;
			kobeya_param[4]=0;
			pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			if(const_flag==1)step=8;
			break;
		case 8:
			kobeya_param[0]=500;
			kobeya_param[1]=4000;
			kobeya_param[4]=0;
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
			pthread_create(&uss_task,&attr_uss,uss_thread,30);
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			pthread_join(uss_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			if(const_flag==1){
				step=9;
				if(r_uss_wall_flag==0)step=14;
				if(l_uss_wall_flag==0)step=16;
			}
			break;
		case 9:
			kobeya_param[0]=500;
			kobeya_param[1]=4000;
			kobeya_param[4]=0;
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
			pthread_create(&uss_task,&attr_uss,uss_thread,30);
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			pthread_join(uss_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			if(const_flag==1){
				step=18;//あやしい
				if(r_uss_wall_flag==0)step=14;
				if(l_uss_wall_flag==0)step=16;
			}
			break;
		case 10:
			kobeya_param[0]=90;
			kobeya_param[1]=800;
			kobeya_param[4]=0;
			pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			if(const_flag==1)step=11;
			break;
		case 11:
			kobeya_param[0]=500;
			kobeya_param[1]=4000;
			kobeya_param[4]=0;
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
			pthread_create(&uss_task,&attr_uss,uss_thread,30);
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			pthread_join(uss_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			if(const_flag==1){
				step=12;
				if(r_uss_wall_flag==0)step=14;
				if(l_uss_wall_flag==0)step=16;
			}
			break;
		case 12:
			kobeya_param[0]=180;
			kobeya_param[1]=1600;
			kobeya_param[4]=0;
			pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			if(const_flag==1)step=13;
			break;
		case 13:
			kobeya_param[0]=1000;
			kobeya_param[1]=8000;
			kobeya_param[4]=0;
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
			pthread_create(&uss_task,&attr_uss,uss_thread,30);
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			pthread_join(uss_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			if(const_flag==1){
				step=18;
				if(r_uss_wall_flag==0)step=14;
				if(l_uss_wall_flag==0)step=16;
			}
			break;
		case 14:
			kobeya_param[0]=90;
			kobeya_param[1]=800;
			kobeya_param[4]=0;
			pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			if(const_flag==1){
				step=15;
				if(kobeya_state==3)step=18;
			}
			break;
		case 15:
			switch(kobeya_state){
				case 1:
					kobeya_param[0]=1000;
					kobeya_param[1]=7000;
					kobeya_param[4]=0;
					break;
				case 2:
					kobeya_param[0]=500;
					kobeya_param[1]=4000;
					kobeya_param[4]=0;
					break;
			}
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
			pthread_create(&uss_task,&attr_uss,uss_thread,30);
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			pthread_join(uss_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			step=18;
			break;
		case 16:
			kobeya_param[0]=-90;
			kobeya_param[1]=800;
			kobeya_param[4]=0;
			pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			if(const_flag==1){
				step=15;
				if(kobeya_state==1)step=18;
			}
			break;
		case 17:
			switch(kobeya_state){
				case 2:
					kobeya_param[0]=500;
					kobeya_param[1]=4000;
					kobeya_param[4]=0;
					break;
				case 3:
					kobeya_param[0]=1000;
					kobeya_param[1]=7000;
					kobeya_param[4]=0;
					break;
			}
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
			pthread_create(&uss_task,&attr_uss,uss_thread,30);
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			pthread_join(motor_task1, NULL);
			pthread_join(uss_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			step=18;
			break;
		case 18:
			step=0;
			break;
	}
	return;
}






