#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <errno.h>
#include "func_extern.h"
#include "motor.h"
#include "control.h"

#include "../original/original.h"
#include "../original/uss_control.h"
int uss_use;
int uss_pid;
int r_uss_wall_flag;
int l_uss_wall_flag;
int f_ts_flag;
int r_ts_flag;
int l_ts_flag;
int r_ws_flag;
int time_end_flag;
int motor_restart_flag;
int const_flag;
int kobeya_exit_flag;
int x_r_tmp,x_l_tmp;
float sp_time;

int r1_def,l1_def,l2_def;

FILE *fp;

int step=0;
int goal_flag=0;
int flag_esc=0;
int motion_param[5];
int kobeya_state=0;
int kobeya_flag=0;
int straight_time=0;
time_t start_time;


int main(){
	int par[4];
	int *rval,*fval,value;
	char *c;
	conor_detect(&c,&rval,&fval);
	printf("c = %c\nrval=%d,fval=%d\n",c,rval,fval);



	fp = fopen("../test_out.txt","w");
	par[0]=0;
	value=rval;
	if(rval==0)goto finish;
	//if(c=='r'){
		par[0]=-value;
		printf("par[0]%d",par[0]);
	//}
	par[1]=1000;
	par[4]=0;
	par[2]=0;
	par[3]=0;
	fd1 = open(M_PORT_L, O_RDWR);
	if(fd1 < 0){
		if(errno == 3) printf("no such file\n");
		else if(errno == 13) printf("permission\n");
		else printf("other\n");
		fprintf(stderr, "fd1 open error\n");
		exit(-1);
	}
	fd2 = open(M_PORT_R, O_RDWR);
	if(fd2 < 0){
		fprintf(stderr, "fd2 open error\n");
		close(fd1);
		exit(-1);
	}
	printf("end\n");

	printf("starting...\n");

	//motor(c, par);
	pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,par);
	//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
	pthread_join(motor_task1, NULL);
	//pthread_join(motor_task2, NULL);

	printf("end\n");

	printf("closing device...\n");
	close(fd1);
	close(fd2);
finish:
	return 0;
}


void fclose_open(char c){
	fclose(fp);
	fp=fopen("../test_out.txt","a");
}

