#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <errno.h>
#include "func_extern.h"
#include "motor.h"
#include "control.h"

#include "../original/original.h"
#include "../original/uss_control.h"
int uss_use;
int uss_pid;
int r_uss_wall_flag;
int l_uss_wall_flag;
int f_ts_flag;
int r_ts_flag;
int l_ts_flag;
int r_ws_flag;
int time_end_flag;
int motor_restart_flag;
int const_flag;
int kobeya_exit_flag;
int x_r_tmp,x_l_tmp;
float sp_time;

int r1_def,l1_def,l2_def;

FILE *fp;

int step=0;
int goal_flag=0;
int flag_esc=0;
int motion_param[5];
int kobeya_state=0;
int kobeya_flag=0;
int straight_time=0;
time_t start_time;


int main(){
	int a=0;
	char c='r';
	int par[4];
	printf("'r'or'c'or'k'");
	scanf("%c",&c);
	a=exit_detect(c);
	printf("exit = %d\n",a);

	fp = fopen("../test_out.txt","w");	
    	if(a==0){goto finish;}
	if(c=='k'){
		par[0]=-a;
	}else if(c=='r'){
		if(a==12){
			par[0]=10;
		}else if(a==9){
			par[0]=-45;
		}else if(a==3){
			par[0]=45;
		}
	}
	par[1]=100;
	par[4]=0;
	par[2]=0;
	par[3]=0;
	fd1 = open(M_PORT_L, O_RDWR);
	if(fd1 < 0){
		if(errno == 3) printf("no such file\n");
		else if(errno == 13) printf("permission\n");
		else printf("other\n");
		fprintf(stderr, "fd1 open error\n");
		exit(-1);
	}
	fd2 = open(M_PORT_R, O_RDWR);
	if(fd2 < 0){
		fprintf(stderr, "fd2 open error\n");
		close(fd1);
		exit(-1);
	}
	printf("end\n");

	printf("starting...\n");

	//motor(c, par);
	pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,par);
	//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
	pthread_join(motor_task1, NULL);
	//pthread_join(motor_task2, NULL);

	printf("end\n");

	printf("closing device...\n");
	close(fd1);
	close(fd2);
finish:
	return 0;
}


void fclose_open(char c){
	fclose(fp);
	fp=fopen("../test_out.txt","a");
}
