/*
 * motor_test.c
 *
 *  Created on: 2013/01/19
 *      Author: d09101
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>
#include <errno.h>
//#include "func_extern.h"
#include "motor.h"
#include "control.h"

//extern void *sub_motor_thread(void);
extern void *const_straight_thread(void*);
extern void *const_rotate_thread(void*);
void fclose_open(char);

int r_uss_wall_flag;
int l_uss_wall_flag;
int uss_pid;
int uss_use;

int f_ts_flag;
int r_ts_flag;
int l_ts_flag;
int r_ws_flag;

float sp_time;
int time_end_flag;
int kobeya_exit_flag;


FILE *fp;

int main(void){

	char c;
	int val,t,r,dir;
	int par[5];
	int s_val;

	printf("mode select\ns:straight\tr:rotate\n\nmode:");
	s_val=scanf("%c",&c);
	printf("\n");
	if(c=='s'){
		printf("val[mm] = ");
		s_val=scanf("%d",&val);
		printf("speed = ");
		s_val=scanf("%d",&t);
		printf("\n");
		par[0]=val;
		par[1]=t;
		par[4]=0;
	}
	if(c=='r'){
		printf("angle[deg] = ");
		s_val=scanf("%d",&val);
		printf("speed = ");
		s_val=scanf("%d",&t);
		printf("\n");
		par[0]=val;
		par[1]=t;
		par[4]=0;
	}

	//sleep(3);

	//pthread_mutex_init(mutex_m,NULL);

	pthread_attr_init (&attr_motor1);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_motor1, SCHED_RR);
	pthread_attr_setschedparam (&attr_motor1, &sched_param);

	pthread_attr_init (&attr_motor2);
	sched_param.sched_priority = 21;
	pthread_attr_setschedpolicy(&attr_motor2, SCHED_RR);
	pthread_attr_setschedparam (&attr_motor2, &sched_param);

	printf("opening device...\n");
	fd1 = open(M_PORT_L, O_RDWR);
	if(fd1 < 0){
		if(errno == 3) printf("no such file\n");
		else if(errno == 13) printf("permission\n");
		else printf("other\n");
		fprintf(stderr, "fd1 open error\n");
		exit(-1);
	}
	fd2 = open(M_PORT_R, O_RDWR);
	if(fd2 < 0){
		fprintf(stderr, "fd2 open error\n");
		close(fd1);
		exit(-1);
	}
	printf("end\n");

	printf("starting...\n");
	fp=fopen("../output/out.txt","w");

	if(c=='s'){
		pthread_create(&motor_task1, &attr_motor1,const_straight_thread,par);
		//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
		pthread_join(motor_task1, NULL);
		//pthread_join(motor_task2, NULL);
	}
	if(c=='r'){
		pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,par);
		//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
		pthread_join(motor_task1, NULL);
		//pthread_join(motor_task2, NULL);
	}

	printf("end\n");

	printf("closing device...\n");
	close(fd1);
	close(fd2);
	printf("end\n");
	printf("Finish!!\n");

	return 0;
}


void fclose_open(char c){
	switch(c){
		case 'f':
			fclose(fp);
			fp=fopen("../output/out.txt","a");
			break;
	}
}

