#include <cv.h>
#include <highgui.h>
#include <cxcore.h>
#include <stdio.h>

#include "./include/CVdefine.h"
#include "./include/CVGV.h"
//#include "./include/CVextern.h"

//int labeling(IplImage *src,IplImage *src,IplImage *src2,int *collect,int *centerpos){
int exit_noisecut(IplImage *src){
	int label_kari[src->width+2][src->height+2];// "1ピクセル目と最後のピクセル時にそれぞれ上のピクセルと下のピクセルを見るので、+2余分に必要"
	int label_true[src->width+2][src->height+2];
	int table[LABEL_MAX][2];	// "[][0]は元データ [][1]は変換すべきデータ"
	int sousa[4]={0,0,0,0};
	int sousa_flag=0;
	int number=0,min=LABEL_MAX;
	int area[LABEL_MAX];
	int n=0;
	int area_temp[LABEL_MAX][2];
	int x,y;//"画素走査用ループ変数"
	int i,j;//ループ用変数
	int harea_r=0,harea_l=0;
//	int counter=0;

	//CvScalar bin;
	uchar bin;

	for(i=0;i<LABEL_MAX;i++){//ラベル変換テーブルの初期化
				table[i][0]=i;
				table[i][1]=i;
				area[i]=0;
				}

	for(y=0;y<src->height;y++){
		for(x=0;x<src->width;x++){
			label_kari[x][y]=0;
			label_true[x][y]=0;
		}
	}

	for(y=0;y<src->height;y++){
		for(x=0;x<src->width;x++){

	bin=src->imageData[src->widthStep*y+x];
	//画素へ直接アクセス(cvGet(Set)Real2Dは重いようなので)

			if(bin==255){

				if(x<(src->width/2))harea_l++;
				else{harea_r++;}

			}

		   if(bin==255 && label_kari[x][y]==0){//もし対象画素ならば

					sousa_flag=0;
					min=LABEL_MAX;

					sousa[0]=label_kari[x-1][y];
					sousa[1]=label_kari[x-1][y-1];
					sousa[2]=label_kari[x][y-1];
					sousa[3]=label_kari[x+1][y-1];


				for(i=0;i<4;i++)sousa_flag+=sousa[i];

				if(sousa_flag==0){//すべてラベルがなかったら"
						number++;
						label_kari[x][y]=number;
						}
				else{//どれかにラベルがあるなら"
				    for(i=0;i<4;i++){
					if(sousa[i]<min && sousa[i]!=0){
							   min=sousa[i];
							}
						}
					label_kari[x][y]=min;

				for(i=0;i<4;i++){//ラベル再定義ルーチン"
					if(sousa[i]!=min && sousa[i]!=0){
						table[sousa[i]][1]=min;


						for(j=0;j<LABEL_MAX;j++){
							if(table[j][1]==sousa[i])
							table[j][1]=min;
						}


						while(1){
							if(table[min][1]!=min){
								min=table[min][1];
								table[sousa[i]][1]=min;
							}else{break;}
							}
						}
					}

				}

			}//"対象画像ならばの終わり"
		}
	}




	for(y=0;y<src->height;y++){
		for(x=0;x<src->width;x++){

		label_true[x][y]=table[label_kari[x][y]][1];
		if(label_true[x][y]!=0)area[label_true[x][y]]++;//面積のカウント"
		else area[label_true[x][y]]=0;

		}
	}


/*	for(x=0;x<src->width;x++){//外枠に触れる領域を０にする
		area[label_true[x][0]]=0;
		area[label_true[x][239]]=0;
	}
	for(y=0;y<src->height;y++){//外枠に触れる領域を０にする
		area[label_true[0][y]]=0;
		area[label_true[319][y]]=0;
	}



	for(i=0;i<LABEL_MAX;i++){

		if(area[i]>10){
				area_temp[n][0]=area[i];//フィルタリング後に残った面積"
				area_temp[n][1]=i;//その時のラベル番号"
				n++;
				}

	}
*/

	for(x=0;x<src->width;x++){//"ラベルイメージの初期化"
		for(y=0;y<src->height;y++){
			src->imageData[src->widthStep*y+x]=0;
		}
	}

	for(i=0;i<LABEL_MAX;i++){
	   if(area[i]>100/*&&area[i]<300*/){
		for(y=0;y<src->height;y++){
			for(x=0;x<src->width;x++){
				if(label_true[x][y]==i)src->imageData[src->widthStep*y+x]=255;
			}
		}
	  }
	}

return 0;
}

int exit_gettrim(IplImage *src,CvRect *rect){
	int x,y,x1,x2,y1,y2;
	IplImage *tempImage;
	uchar col;
		x1=-1,x2=-1,y1=-1,y2=-1;
			tempImage=cvCreateImage(cvGetSize(src),IPL_DEPTH_8U,1);
			cvCopy(src,tempImage,NULL);
		for(x=0;x<tempImage->width;x++){
			for(y=0;y<tempImage->height;y++){
			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					x1=x;
					break;
				}
			}
			if(x==x1)break;
		}
		for(y=0;y<tempImage->height;y++){
			for(x=0;x<tempImage->width;x++){
			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					y1=y;
					break;
				}
			}
			if(y==y1)break;
		}
		for(x=(tempImage->width)-1;x>=0;x--){
			for(y=(tempImage->height)-1;y>=0;y--){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					x2=x;
					break;
				}
			}
			if(x==x2)break;
		}
		for(y=(tempImage->height)-1;y>=0;y--){
			for(x=(tempImage->width)-1;x>=0;x--){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					y2=y;
					break;
				}
			}
			if(y==y2)break;
		}
	*rect=cvRect(x1,y1,x2-x1,y2-y1);
	cvReleaseImage(&tempImage);
	return 0;

}
int exit_crop(IplImage *src,CvPoint *point){

	int x,y,x1=-1,x_flag=0,y1=-1,y_flag=0;
	IplImage *tempImage;
	uchar col;
		tempImage=cvCreateImage(cvGetSize(src),IPL_DEPTH_8U,1);
		cvCopy(src,tempImage,NULL);
		for(x=0;x<tempImage->width;x++){
			for(y=0;y<tempImage->height;y++){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					x1=x;
					break;
				}
			}
			if(x==x1)break;
		}
		for(y=0;y<tempImage->height;y++){
			for(x=0;x<tempImage->width;x++){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					y1=y;
					break;
				}
			}
			if(y==y1)break;
		}
	if(x1==0){
		for(x=0;x<tempImage->width;x++){
			for(y=0;y<tempImage->height;y++){
			col=tempImage->imageData[tempImage->widthStep*y+x];
				if(col==255 && x_flag==0){
					if(y1<=y){
						y1=y;
						x1=x;
						x_flag=1;

					}
				break;
				}
			}
			x_flag=0;
		}
	}
	if(y1==0){
		for(y=0;y<tempImage->height;y++){
			for(x=0;x<tempImage->width;x++){
			col=tempImage->imageData[tempImage->widthStep*y+x];
				if(col==255 && y_flag==0){
					if(x1<=x){
						y1=y;
						x1=x;
						y_flag=1;
					}
				break;
				}
			}
			y_flag=0;
		}
	}
	*point=cvPoint(x1,y1);
	cvReleaseImage(&tempImage);
	return 0;
}

#define MAINASU 80
int exit_cut1(IplImage *src){
	int x,y,x1=-1,x_flag=0,y1=-1,y_flag=0,line_flag=0;
	uchar col;
		for(x=0;x<src->width;x++){
			for(y=0;y<src->height;y++){
				col=src->imageData[src->widthStep*y+x];
				if(col==255){
					if(y-line_flag<5 && y-line_flag>1){
					if(line_flag>y1)y1=line_flag;
					}
					line_flag=y;
				}
			}
		line_flag=0;
		}
		for(x=0;x<src->width;x++){
			for(y=0;y<y1;y++){
					src->imageData[src->widthStep*y+x]=0;
			}
			for(y=y1;y<src->height-MAINASU;y++){
					src->imageData[src->widthStep*y+x]=255;
			}
		}
	return 0;
}
int exit_cut2(IplImage *src){
	int x,y,x1=-1,x_flag=0,y1=-1,y_flag=0,line_flag=0;
	uchar col;
		for(x=0;x<src->width;x++){
			for(y=0;y<src->height-MAINASU;y++){
				col=src->imageData[src->widthStep*y+x];
				if(col==255){
					x_flag=1;
				}
				if(x_flag==1)src->imageData[src->widthStep*y+x]=255;
			}
		x_flag=0;
		}
	return 0;
}

void exit_triming(IplImage *src,IplImage *dst,CvRect rect){
cvSetImageROI(src,rect);
cvCopy(src,dst,NULL);
cvResetImageROI(src);
}

#define DIV 2
#define ADJ 5
int select_exit(IplImage *src  ,int *exit){

	int exit_w=0;//横幅
	int exit_h=0;//縦幅
	int ans=-1;
	int x,y,i=0;
	int ptx1=-1,ptx2=-1;
	int ptx;

	uchar col;
			exit_w=src->width;
			exit_h=src->height;
	for(x=0;x<exit_w;x++){
			col=src->imageData[src->widthStep*ADJ*(exit_h/10)+x];
			if(col==255){
				ptx1=x;
				break;
			}
			src->imageData[src->widthStep*ADJ*(exit_h/10)+x]=255;
		}
	for(x=exit_w;x>=0;x--){
			col=src->imageData[src->widthStep*ADJ*(exit_h/10)+x];
			if(col==255){
				ptx2=x;
				break;
			}
			src->imageData[src->widthStep*ADJ*(exit_h/10)+x]=255;
		}
	if(ptx1==-1){
		//printf("rotary_error\n");
		ans=3;
	}else if(ptx1<exit_w/DIV && ptx2>exit_w/DIV){
		ans=9;
	}else if(ptx1<=exit_w/DIV){
		ans=9;
	}else if(ptx1>exit_w/DIV){
		ans=12;
	}/*else{
		ans=12;
	}*/
	*exit=ans;
return 0;
}


#include<math.h>

#define A 9
#define B 8
int select_val(IplImage *src ,int *exit){
	int exit_w=0;//横幅
	int exit_h=0;//縦幅
	int point_x,point_y;
	int ans=-1,ans1=-1;
	int x,y,i=0,flag=-1,area;
	int line_val,forside;
	int pt1,pt2,pt3,line=0;
	int pt11,pt22,pt33;
	char c;
	uchar col;
		exit_w=src->width;
		exit_h=src->height;

		for(x=0;x<exit_w;x++){
			col=src->imageData[src->widthStep*A*(exit_h/10)+x];
			if(col==255){
				i++;
			}else{
				if(i>=2&&i<=7){
					line++;
					if(line==1){
						pt1=x;
					}else if(line==2){
						pt2=x;
					}else if(line==3){
						pt3=x;
					}
				}
				i=0;
			}
			src->imageData[src->widthStep*A*(exit_h/10)+x]=255;
		}
/*		line=0;
		for(x=0;x<exit_w;x++){
			col=src->imageData[src->widthStep*B*(exit_h/10)+x];
			if(col==255){
				i++;
			}else{
				if(i>=2&&i<5){
					line++;
					if(line==1){
						pt11=x;
					}else if(line==2){
						pt22=x;
					}else if(line==3){
						pt33=x;
					}
				}
				i=0;
			}
			src->imageData[src->widthStep*B*(exit_h/10)+x]=0;
		}
*/
		src->imageData[src->widthStep*A*(exit_h/10)+pt1]=0;
		src->imageData[src->widthStep*A*(exit_h/10)+pt2]=0;

		if(line!=2&&line!=1){
			printf("line=%d->exit",line);
			line_val=pt2-pt1;
			if(line_val >60 && line_val < 40)
			pt2=pt3;
			return -1;
		}

		printf("line=%d,pt1=%d,pt2=%d\n",line,pt1,pt2);
		if(line==1){if(pt1>exit_w/2){ans1=45;}else{ans1=-45;}}
   else{
		line_val=pt2-pt1;

		if(exit_w/2<pt1+line_val/2){c='R';ans=pt1+line_val/2-exit_w/2;}
		else{c='L';ans=pt1+line_val/2-exit_w/2;}

	}
		if(line==2){
		//ans1=(ans/1.6)*0.47;//*47;
			ans1=(3/8)*ans;
		}
		printf("ans=%d",ans);
		printf("direct=%c\n",c);
		printf("ans1=%d\n",ans1);
		*exit=ans1;
return 0;
}
#define DI 4
#define AD 5
int exit_val(IplImage *src  ,int *exit){
	int exit_w=0;//横幅
		int exit_h=0;//縦幅
		int point_x,point_y;
		int ans=-1,ans1=-1;
		int x,y,i=0,flag=-10,area;
		int line_val,forside;
		int pt1,pt2,pt3,line=0;
		int pt11,pt22,pt33;
		char c;
		uchar col;
			exit_w=src->width;
			exit_h=src->height;

			for(x=0;x<exit_w;x++){
				col=src->imageData[src->widthStep*(exit_h/2)+x];
					if(col==255){
						line++;
						if(x-flag<10){line--;}
						if(line==1){pt1=x;
						}else if(line==2){pt2=x;
						}
						flag=x;
					}
				
			}

			if(line!=2&&line!=1){
				printf("line=%d->exit",line);
			//	line_val=pt2-pt1;
			//	if(line_val >60 && line_val < 40)
			//	pt2=pt3;
	//			ans1=0;
				return -1;
			}

			printf("line=%d,pt1=%d,pt2=%d\n",line,pt1,pt2);
			if(line==1){if(pt1>exit_w/2){ans1=45;}else{ans1=-45;}
			}else{
				line_val=pt2-pt1;
				if(exit_w/2<pt1+line_val/2){c='R';ans=pt1+line_val/2-exit_w/2;
				}else{c='L';ans=pt1+line_val/2-exit_w/2;
				}
				//if(line==2){
				ans1=(ans/8)*3;//*47;
				//ans1=(3/8)*ans;
				//}
			}

			printf("ans=%d",ans);
			printf("direct=%c\n",c);
			printf("ans1=%d\n",ans1);
			*exit=ans1;
return 0;
}

void triming1(IplImage *src,IplImage *dst,CvRect rect){
cvSetImageROI(src,rect);
cvCopy(src,dst,NULL);
cvResetImageROI(src);
}

