#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "cv.h"
#include "highgui.h"
/*
void img_update(char *str, int width, int height){
	char command[100];
	sprintf(command, "uvccapture -o%s -x%d -y%d\n", str, width, height);
	int sy_val=system(command);
	usleep(10*1000);
	return;
}
*/
void img_update(char *str, int width, int height)
{
	//width=0;height=0;//warning回避
	//カメラから取り込む
	//cvCreateCameraCaptureに0を指定すると、最初に見つかるカメラデバイスが選ばれます。
	CvCapture *capture = cvCreateCameraCapture(0);

	//カメラが無い時用
	//CvCapture *capture = cvCrateFileCapture(動画ファイル名);

	//カメラのサイズを取り込みます。 cvGetCapturePropertyの戻り値はdoubuleなので、intにキャスト
	CvSize size=cvSize
	(
		(int)cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_WIDTH ),
		(int)cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_HEIGHT )
	);
	CvSize size1=cvSize
	(
		width,
		height
	);
	//カメラから取得したデータ用
	IplImage * CapturedFrame;

	//縮小用
	IplImage *dst;

	//データを格納する
	CapturedFrame=cvCreateImage(size,IPL_DEPTH_8U,3);

	//1フレームキャプチャ
	CapturedFrame=cvQueryFrame(capture);
	//if(!CapturedFrame) return ;


	dst = cvCreateImage( size1,IPL_DEPTH_8U, 3);
	cvResize(CapturedFrame,dst,CV_INTER_CUBIC);
	cvSaveImage(str,dst,0);

	//リソースを開放
	cvReleaseCapture(&capture);
	cvReleaseImage(&dst);
	cvReleaseImage(&CapturedFrame);
	return;
}
