#include <cv.h>
#include <highgui.h>
#include <cxcore.h>
#include <stdio.h>

#include "./include/CVdefine.h"
#include "./include/CVGV.h"
#include "./include/CVextern.h"

int labeling(IplImage *src,IplImage *dst1,IplImage *dst2,int *lab_num1,int *lab_num2){
//int labeling(IplImage *src,IplImage *dst1,IplImage *dst2){
	int label_kari[src->width+2][src->height+2];// "1ピクセル目と最後のピクセル時にそれぞれ上のピクセルと下のピクセルを見るので、+2余分に必要" 
	int label_true[src->width+2][src->height+2];
	int table[LABEL_MAX][2];	// "[][0]は元データ [][1]は変換すべきデータ" 
	int sousa[4]={0,0,0,0};
	int sousa_flag=0;
	int number=0,min=LABEL_MAX;
	int area[LABEL_MAX];
	int n=0;
	int area_temp[LABEL_MAX][2];
	int area_max=0,area_nmax=0,area_nnmax=0;;
	int max_num=0,nmax_num=0,nnmax_num=0;
	int x,y;//"画素走査用ループ変数" 
	int i,j;//ループ用変数
	int harea_r=0,harea_l=0;
	int cancel=0;
//	int counter=0;

	//CvScalar bin;
	uchar bin;

	for(i=0;i<LABEL_MAX;i++){//ラベル変換テーブルの初期化
				table[i][0]=i;
				table[i][1]=i;
				area[i]=0;
				}

	for(y=0;y<src->height;y++){
		for(x=0;x<src->width;x++){
			label_kari[x][y]=0;
			label_true[x][y]=0;
		}
	}

	for(y=0;y<src->height;y++){
		for(x=0;x<src->width;x++){

	bin=src->imageData[src->widthStep*y+x];
	//画素へ直接アクセス(cvGet(Set)Real2Dは重いようなので)
			
			if(bin==255){
			
				if(x<(src->width/2))harea_l++;
				else{harea_r++;}
			
			}

		   if(bin==255 && label_kari[x][y]==0){//もし対象画素ならば

					sousa_flag=0;
					min=LABEL_MAX;

					sousa[0]=label_kari[x-1][y];
					sousa[1]=label_kari[x-1][y-1];
					sousa[2]=label_kari[x][y-1];
					sousa[3]=label_kari[x+1][y-1];
					

				for(i=0;i<4;i++)sousa_flag+=sousa[i];

				if(sousa_flag==0){//すべてラベルがなかったら" 
						number++;
						label_kari[x][y]=number;
						}
				else{//どれかにラベルがあるなら" 
				    for(i=0;i<4;i++){
					if(sousa[i]<min && sousa[i]!=0){
							   min=sousa[i];
							}
						}
					label_kari[x][y]=min;

				for(i=0;i<4;i++){//ラベル再定義ルーチン" 
					if(sousa[i]!=min && sousa[i]!=0){
						table[sousa[i]][1]=min;


						for(j=0;j<LABEL_MAX;j++){
							if(table[j][1]==sousa[i])
							table[j][1]=min;		
						}


						while(1){
							if(table[min][1]!=min){				
								min=table[min][1];
								table[sousa[i]][1]=min;
							}else{break;}
							}
						}
					}

				}

			}//"対象画像ならばの終わり" 
		}
	}




	for(y=0;y<src->height;y++){
		for(x=0;x<src->width;x++){

		label_true[x][y]=table[label_kari[x][y]][1];
		if(label_true[x][y]!=0)area[label_true[x][y]]++;//面積のカウント" 
		else area[label_true[x][y]]=0;

		}
	}


/**/	for(x=0;x<src->width;x++){//外枠に触れる領域を０にする
		area[label_true[x][0]]=0;
		area[label_true[x][109]]=0;
	}
	for(y=0;y<src->height;y++){//外枠に触れる領域を０にする
		area[label_true[0][y]]=0;
		area[label_true[319][y]]=0;
	}



	for(i=0;i<LABEL_MAX;i++){

		if(area[i]>IGNSIZE){
				area_temp[n][0]=area[i];//フィルタリング後に残った面積" 
				area_temp[n][1]=i;//その時のラベル番号" 
				n++;
				}

	}

	
	for(i=0;i<n;i++){//"最大面積の検出" 

		if(area_max<area_temp[i][0]){
					area_max=area_temp[i][0];
					max_num=area_temp[i][1];
		}

	}

	for(i=0;i<n;i++){//２番目に大きい面積の検出" 

		if(area_nmax<area_temp[i][0] && area_temp[i][0]!=area_max){
					area_nmax=area_temp[i][0];
					nmax_num=area_temp[i][1];
		}

	}

	for(i=0;i<n;i++){//3番目に大きい面積の検出" 

		if(area_nnmax<area_temp[i][0] && area_temp[i][0]!=area_max && area_temp[i][0]!=area_nmax){
					area_nnmax=area_temp[i][0];
					nnmax_num=area_temp[i][1];
		}

	}
	printf("area1=%d\n",area_max);
	printf("area1=%d\n",area_nmax);
//***********追加で書いたところ**********************************************

	int area_nnnmax=0;
	int nnnmax_num=0;
	
	int area_nnnnmax=0;
	int nnnnmax_num=0;
	
	for(i=0;i<n;i++){//4番目に大きい面積の検出" 

		if(area_nnnmax<area_temp[i][0] && area_temp[i][0]!=area_max && area_temp[i][0]!=area_nmax && area_temp[i][0]!=area_nnmax){
					area_nnnmax=area_temp[i][0];
					nnnmax_num=area_temp[i][1];
		}

	}

	for(i=0;i<n;i++){//5番目に大きい面積の検出" 

		if(area_nnnnmax<area_temp[i][0] && area_temp[i][0]!=area_max && area_temp[i][0]!=area_nmax && area_temp[i][0]!=area_nnmax && area_temp[i][0]!=area_nnnmax){
					area_nnnnmax=area_temp[i][0];
					nnnnmax_num=area_temp[i][1];
		}

	}



//**************************************************************************
	if(area_max==0 || area_nmax==0 ){
		return -1;	//OpenCVのエラー回避のためにここでエラー起きるかどうか判断" 
	}

	for(x=0;x<src->width;x++){//"ラベルイメージの初期化" 
		for(y=0;y<src->height;y++){
			dst1->imageData[dst1->widthStep*y+x]=0;
			dst2->imageData[dst2->widthStep*y+x]=0;
		}
	}


	if(lab_num1==1){
		for(y=0;y<src->height;y++){
			for(x=0;x<src->width;x++){
				if(label_true[x][y]==max_num)dst1->imageData[dst1->widthStep*y+x]=255;
			}
		}
	}else if(lab_num1==2){
		for(y=0;y<src->height;y++){
			for(x=0;x<src->width;x++){
				if(label_true[x][y]==nmax_num)dst1->imageData[dst1->widthStep*y+x]=255;
			}
		}
	}else if(lab_num1==3){
		for(y=0;y<src->height;y++){
			for(x=0;x<src->width;x++){
				if(label_true[x][y]==nnmax_num)dst1->imageData[dst1->widthStep*y+x]=255;
			}
		}
	}else if(lab_num1==4){
		for(y=0;y<src->height;y++){
			for(x=0;x<src->width;x++){
				if(label_true[x][y]==nnnmax_num)dst1->imageData[dst1->widthStep*y+x]=255;
			}
		}
	}else if(lab_num1==5){
		for(y=0;y<src->height;y++){
			for(x=0;x<src->width;x++){
				if(label_true[x][y]==nnnnmax_num)dst1->imageData[dst1->widthStep*y+x]=255;
			}
		}
	}
	if(lab_num2==2){
		for(y=0;y<src->height;y++){
			for(x=0;x<src->width;x++){
				if(label_true[x][y]==nmax_num)dst2->imageData[dst1->widthStep*y+x]=255;
			}
		}
	}else if(lab_num2==3){
		for(y=0;y<src->height;y++){
			for(x=0;x<src->width;x++){
				if(label_true[x][y]==nnmax_num)dst2->imageData[dst1->widthStep*y+x]=255;
			}
		}
	}else if(lab_num2==4){
		for(y=0;y<src->height;y++){
			for(x=0;x<src->width;x++){
				if(label_true[x][y]==nnnmax_num)dst2->imageData[dst1->widthStep*y+x]=255;
			}
		}
	}else if(lab_num2==5){
		for(y=0;y<src->height;y++){
			for(x=0;x<src->width;x++){
				if(label_true[x][y]==nnnnmax_num)dst2->imageData[dst1->widthStep*y+x]=255;
			}
		}
	}





//****************************まさかの時の対応******************************
	/*
	CvRect rect1,rect2;
	if(gettrim(dst1,&rect1)==-1){
		printf("1番目失敗\n");
		cancel=3;
		for(x=0;x<src->width;x++){//"ラベルイメージの初期化" 
			for(y=0;y<src->height;y++){
				dst1->imageData[dst1->widthStep*y+x]=0;
			}
		}
		for(y=0;y<src->height;y++){
			for(x=0;x<src->width;x++){
				if(label_true[x][y]==nnmax_num)dst1->imageData[dst1->widthStep*y+x]=255;
			}
		}
		if(gettrim(dst1,&rect1)==-1){
			printf("3番目失敗\n");
			cancel=4;
			for(x=0;x<src->width;x++){//"ラベルイメージの初期化" 
				for(y=0;y<src->height;y++){
					dst1->imageData[dst1->widthStep*y+x]=0;
				}
			}
			for(y=0;y<src->height;y++){
				for(x=0;x<src->width;x++){
					if(label_true[x][y]==nnnmax_num)dst1->imageData[dst1->widthStep*y+x]=255;
				}
			}
			if(gettrim(dst1,&rect1)==-1){	
				printf("4番目失敗\n");
				cancel=5;
				for(x=0;x<src->width;x++){//"ラベルイメージの初期化" 
					for(y=0;y<src->height;y++){
						dst1->imageData[dst1->widthStep*y+x]=0;
					}
				}
				for(y=0;y<src->height;y++){
					for(x=0;x<src->width;x++){
						if(label_true[x][y]==nnnnmax_num)dst1->imageData[dst1->widthStep*y+x]=255;
					}
				}
			}
		}
	}
	if(gettrim(dst2,&rect2)==-1){
		printf("2番目失敗\n");
		if(cancel!=3){
			for(x=0;x<src->width;x++){//"ラベルイメージの初期化" 
				for(y=0;y<src->height;y++){
					dst2->imageData[dst2->widthStep*y+x]=0;
				}
			}
			for(y=0;y<src->height;y++){
				for(x=0;x<src->width;x++){
					if(label_true[x][y]==nnmax_num)dst2->imageData[dst2->widthStep*y+x]=255;
				}
			}
		}	
		if(gettrim(dst2,&rect2)==-1){
			printf("3番目失敗\n");
			if(cancel!=4){
				for(x=0;x<src->width;x++){//"ラベルイメージの初期化" 
					for(y=0;y<src->height;y++){
						dst2->imageData[dst2->widthStep*y+x]=0;
					}
				}
				for(y=0;y<src->height;y++){
					for(x=0;x<src->width;x++){
						if(label_true[x][y]==nnnmax_num)dst2->imageData[dst2->widthStep*y+x]=255;
					}
				}
			}
			if(gettrim(dst2,&rect2)==-1){	
				printf("4番目失敗\n");
				for(x=0;x<src->width;x++){//"ラベルイメージの初期化" 
					for(y=0;y<src->height;y++){
						dst2->imageData[dst2->widthStep*y+x]=0;
					}
				}
				for(y=0;y<src->height;y++){
					for(x=0;x<src->width;x++){
						if(label_true[x][y]==nnnnmax_num)dst2->imageData[dst2->widthStep*y+x]=255;
					}
				}
			}
		}
	}
*/
//********************************************************************


return 0;	
}


int gettrim(IplImage *src,CvRect *rect){

	int x,y,x1,x2,y1,y2;
	IplImage *tempImage;
	uchar col;

		x1=-1,x2=-1,y1=-1,y2=-1;

			tempImage=cvCreateImage(cvGetSize(src),IPL_DEPTH_8U,1);
//			tempImage=cvCloneImage(src);
			cvCopy(src,tempImage,NULL);
		for(x=0;x<tempImage->width;x++){
			for(y=0;y<tempImage->height;y++){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					x1=x;
					break;
				}
			}
			if(x==x1)break;
		}


		for(y=0;y<tempImage->height;y++){
			for(x=0;x<tempImage->width;x++){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					y1=y;
					break;
				}
			}
			if(y==y1)break;
		}


		for(x=(tempImage->width)-1;x>=0;x--){
			for(y=(tempImage->height)-1;y>=0;y--){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					x2=x;
					break;
				}
			}
			if(x==x2)break;
		}


		for(y=(tempImage->height)-1;y>=0;y--){
			for(x=(tempImage->width)-1;x>=0;x--){

			col=tempImage->imageData[tempImage->widthStep*y+x];

				if(col==255){
					y2=y;
					break;
				}
			}
			if(y==y2)break;
		}
		
//*********************************************************
	//	printf("x1=%d,x2=%d,y1=%d,y2=%d,x=%d,y=%d\n",x1,x2,y1,y2,(tempImage->width)-1),(tempImage->height)-1;

		if(x1==0)
			return -1;
		if(y1==0)
			return -1;
		if(x2==319)
			return -1;
		if(y2==239)
			return -1;

//*******************************************************
		*rect=cvRect(x1,y1,x2-x1,y2-y1);

	cvReleaseImage(&tempImage);

	return 0;

}

void triming(IplImage *src,IplImage *dst,CvRect rect){

cvSetImageROI(src,rect);
cvCopy(src,dst,NULL);
cvResetImageROI(src);

	
	
}



