#include <cv.h>
#include <highgui.h>
#include <cxcore.h>
#include <stdio.h>

#include "./include/CVdefine.h"
#include "./include/CVGV.h"
#include "./include/CVextern.h"


void noisecut(IplImage *src,IplImage *dst){

	uchar bin,binold=0;
	int cnt;
	int scanflag=0;
	int max=0;
	int ystart=0,ytemp=0;
	int x,y;
	
	cvCopy(src,dst,NULL);
	
	for(x=0;x<src->width;x++){
		cnt=0;
		scanflag=0;
		for(y=0;y<src->height;y++){
			
			bin=src->imageData[src->widthStep*y+x];
			
			if(bin==255){
				scanflag=1;
				if(max<cnt){
					max=cnt;
					ystart=ytemp;
				}
				cnt=0;
			}
			if(scanflag==1 && bin==0){
				cnt++;
				if(binold==255)ytemp=y;
			}
			binold=bin;
		}
	}
	
	for(x=0;x<src->width;x++){
		for(y=0;y<ystart;y++){
			dst->imageData[dst->widthStep*y+x]=255;
		}
	}
	
}




