#include<cv.h>
#include<highgui.h>
#include<cxcore.h>
#include <stdio.h>

#include "./include/CVGV.h"

#define DIV 4


void select_number(IplImage *src1,IplImage *src2,int *num1,int *num2){

	IplImage *targetImage;

	int num_w=0;
	int num_h=0;
	
	int x,y,i,area;

	int f1,f2,f3,f4,f5,f6,f7;

	uchar col;

	for(i=1;i<=2;i++){

		f1=f2=f3=f4=f5=f6=f7=0;
		area=0;
		int ans=-1;

		if(i==1){
		   targetImage=cvCreateImage(cvGetSize(src1),IPL_DEPTH_8U,1);
			targetImage=cvCloneImage(src1);
			num_w=src1->width;
			num_h=src1->height;
			}

		if(i==2){
		   targetImage=cvCreateImage(cvGetSize(src2),IPL_DEPTH_8U,1);
			targetImage=cvCloneImage(src2);
			num_w=src2->width;
			num_h=src2->height;
			}


		for(x=0;x<num_w/DIV;x++){
		col=targetImage->imageData[targetImage->widthStep*(num_h/4)+x];
			if(col==255){
						f1=1;
						break;
							}
		}

		for(x=num_w-1;x>=num_w-num_w/DIV;x--){
		col=targetImage->imageData[targetImage->widthStep*(num_h/4)+x];
			if(col==255){
						f2=1;
						break;
							}
		}

		for(x=0;x<num_w/DIV;x++){
		col=targetImage->imageData[targetImage->widthStep*(3*num_h/4)+x];
			if(col==255){
						f3=1;
						break;
							}
		}

		for(x=num_w-1;x>=num_w-num_w/DIV;x--){
		col=targetImage->imageData[targetImage->widthStep*(3*num_h/4)+x];
			if(col==255){
						f4=1;
						break;
							}
		}

		for(y=0;y<num_h/DIV;y++){
		col=targetImage->imageData[targetImage->widthStep*y+(num_w/2)];
			if(col==255){
						f5=1;
						break;
							}
		}

		for(y=num_h-1;y>=num_h-num_h/DIV;y--){
		col=targetImage->imageData[targetImage->widthStep*y+(num_w/2)];
			if(col==255){
						f6=1;
						break;
							}
		}

		for(y=num_h/4;y<3*num_h/4;y++){
		col=targetImage->imageData[targetImage->widthStep*y+(num_w/2)];
			if(col==255){
						f7=1;
						break;
							}
		}


	 	     if(  f7==0 && (f1&f2&f3&f4&f5&f6)==1)ans=0;
	 	else if((f1|f4)==0 && (f2&f3&f5&f6&f7)==1)ans=2;
	 	else if((f1|f3)==0 && (f2&f4&f5&f6&f7)==1)ans=3;
	 	else if((f3|f5|f6)==0 && (f1&f2&f4&f7)==1)ans=4;
	 	else if((f2|f3)==0 && (f1&f4&f5&f6&f7)==1)ans=5;
	 	else if(  f6==0 && (f1&f2&f3&f4&f5&f7)==1)ans=6;
	 	else if((f3|f6|f7)==0 && (f1&f2&f4&f5)==1)ans=7;
	 	else if(        (f1&f2&f3&f4&f5&f6&f7)==1)ans=8;
		else if(  f3==0 && (f1&f2&f4&f5&f6&f7)==1)ans=9;

		if((num_h / num_w)>=4)ans=1;

//tB^O###############################################################################
		
		//@c¡äÉæétB^O
			if(num_w > num_h)ans=-1;
		
	//AÊÏÆÊÏÌärÉæétB^O
			for(y=0;y<num_h;y++){//±±ÅX^XL·éÌ·­µÄŸ¯ÇAŒÌÖÉË¶³¹œ­È¢ÌÅ±±ÅÄÑEEE
				for(x=0;x<num_w;x++){
					col=targetImage->imageData[targetImage->widthStep*y+x];
					if(col==255)area++;
				}
			}
			if(((int)((num_h*num_w)*0.7) < area) && ans!=1)ans=-1;
		
		//BñæÌ³AÌärÉæétB^O(u1vÌêð­)
			if(i==2 && *num1!=1 && ans!=1){
				if(src1->height > src2->height){
					if(src1->height / src2->height >=2)ans=-1;
				else{
					if(src2->height / src1->height >=2)*num1=-1;
				}}
				
				if(src1->width > src2->width){
					if(src1->width / src2->width >=2)ans=-1;
				else{
					if(src2->width / src1->width >=2)*num1=-1;
				}}
			}
//##############################################################################################
		
		if(i==1)*num1=ans;
		if(i==2)*num2=ans;
		
	//printf("1=%d,2=%d,3=%d,4=%d,5=%d,6=%d,7=%d\n",f1,f2,f3,f4,f5,f6,f7);

	}
	
	cvReleaseImage(&targetImage);

}
