#include<cv.h>
#include<highgui.h>
#include<cxcore.h>

#include "./include/CVdefine.h"
#include "./include/CVGV.h"


void threshold(IplImage *src,IplImage *dst,int otsuflag){

	IplImage *grayImage;

	grayImage=cvCreateImage(cvGetSize(src),IPL_DEPTH_8U,1);

	cvCvtColor(src,grayImage,CV_BGR2GRAY);

	if(otsuflag==1)cvThreshold(grayImage,dst,THRESHOLD,THRESHOLD_MAX,CV_THRESH_BINARY_INV | CV_THRESH_OTSU);
	else if(otsuflag==0)cvThreshold(grayImage,dst,THRESHOLD,THRESHOLD_MAX,CV_THRESH_BINARY_INV | CV_THRESH_OTSU);
	
	cvReleaseImage(&grayImage);

}
