#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>

#include "../main/func_extern.h"
#include "../main/control.h"
#include "../uss/uss.h"
#include "../motor/motor.h"
//#include "../main/irs_ts_ws.h"

int f_ts_flag=0;
int r_ts_flag=0;
int l_ts_flag=0;
int r_ws_flag=0;
int ws_lock_flag=0;//緊急に白線センサの検知をロックする変数を設ける
extern int ts_exit_flag;

void *irs_ts_ws_thread(void)
{

	int i;
	int mark;
	int ret;

	char *irs_data;
	char irs_dat[12];//13
	ts_exit_flag=0;

	printf("irs_ts_ws_thread in\n");
	while(1) {
		mark=0;
		irs_data=irs_dat;
		ret = read(fd4,irs_data,12);//13
		//printf("ret = %d\n",ret);
        	//for(i=4;i<5;i++){
        	for(i=0;i<8;i++){
			irs_dat[i]=*irs_data;
           		irs_data++;
       		}
			for(i=8;i<12;i++){
				irs_dat[i]=*irs_data;
				irs_data++;
			}

		if(irs_dat[2]=='1'&&ws_lock_flag!=1)r_ws_flag=1;
		else r_ws_flag=0;
		if(irs_dat[10]=='1')f_ts_flag=1;
		else f_ts_flag=0;
		if(irs_dat[8]=='1')r_ts_flag=1;
		else r_ts_flag=0;
		if(irs_dat[11]=='1')l_ts_flag=1;
		else l_ts_flag=0;

		if(ts_exit_flag==1)break;
		usleep(100);
	}
	pthread_exit(0);
	return 0;
}

void irs_ts_ws_get(void){
	int i;
	char *irs_data;
	char irs_dat[12];
	irs_data=irs_dat;
	read(fd4,irs_data,12);//13
    for(i=0;i<8;i++){
	irs_dat[i]=*irs_data;
    	irs_data++;
   		}
	for(i=8;i<12;i++){
		irs_dat[i]=*irs_data;
		irs_data++;
	}
	if(irs_dat[2]=='1')r_ws_flag=1;
	else r_ws_flag=0;
	if(irs_dat[10]=='1')f_ts_flag=1;
	else f_ts_flag=0;
	if(irs_dat[8]=='1')r_ts_flag=1;
	else r_ts_flag=0;
	if(irs_dat[11]=='1')l_ts_flag=1;
	else l_ts_flag=0;
	return ;
}
