/*
 * judge_state.c
 *
 *  Created on: 2012/12/16
 *      Author: Hayato
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <errno.h>
#include "func_extern.h"
#include "motor.h"
#include "control.h"

#include "original.h"

extern int r_uss_wall_flag;
extern int l_uss_wall_flag;
extern int f_ts_flag;
extern int r_ts_flag;
extern int l_ts_flag;
extern int r_ws_flag;
extern int motor_restart_flag;
extern int const_flag;
extern int time_end_flag;
extern int uss_exit_flag;
extern int timer_exit_flag;
extern int ts_exit_flag;
extern enum states {STRAIGHT,TIMER_STRAIGHT,MOTOR_RESTART,R_RESTORE,L_RESTORE,R_TURN,R_RETURN,L_TURN,L_RETURN,KEY,DB,ROTARY,KOBEYA,GOAL};
extern enum states state,state_tmp;

extern int timer_straight_speed;
extern int straight_time;

extern int obst;
extern int kobeya_state;

int rotary_center;
int rotary_distance;

extern FILE *fp,*uss_fp;

//extern int straight_time;

void judge_state(void){
	int i,uss_data_now[4];
	int *val,*f_val;
	char c;

	irs_ts_ws_get();
	if(motor_restart_flag==1){
		state=MOTOR_RESTART;
		flag_reset();
		return;
	}
	if(r_ws_flag==1){
		state=DB;
		if(obst==5)state=GOAL;
		flag_reset();
		return;
	}
	if(r_ts_flag==1){
		state=R_RESTORE;
		flag_reset();
		return;
	}
	if(l_ts_flag==1){
		state=L_RESTORE;
		flag_reset();
		return;
	}
	if(f_ts_flag==1){
		state=TIMER_STRAIGHT;
		straight_time=1;
		timer_straight_speed=-30;
		if(obst==1){	
			uss_data_now[2]=uss_get(3);
			usleep(50000);
			printf("uss[3] = %d\n",uss_data_now[2]);
			uss_data_now[1]=uss_get(2);
			usleep(50000);
			printf("uss[2] = %d\n",uss_data_now[1]);
			if(uss_data_now[1]<40&&uss_data_now[2]<40)state=KEY;
		}
		flag_reset();
		return;
	}
	if(r_uss_wall_flag==0 || l_uss_wall_flag==0){
		/*if(obst==2){
			straight_time=5;
			state=TIMER_STRAIGHT;
			obst=-1;
			flag_reset();
			return;
		}*/
		uss_data_now[0]=uss_get(1);
		usleep(50000);
		printf("judge_uss[1] = %d\n",uss_data_now[0]);
		uss_data_now[3]=uss_get(4);
		usleep(50000);
		printf("judge_uss[4] = %d\n",uss_data_now[3]);
		uss_data_now[2]=uss_get(3);
		usleep(50000);
		printf("judge_uss[3] = %d\n",uss_data_now[2]);
		uss_data_now[1]=uss_get(2);
		usleep(50000);
		printf("judge_uss[2] = %d\n",uss_data_now[1]);

		for(i=0;i<4;i++){
			fprintf(uss_fp,"judge_uss%d = %d\n",i+1,uss_data_now[i]);
			fprintf(fp,"judge_uss%d = %d\n",i+1,uss_data_now[i]);
		}
		fclose_open('u');
		fclose_open('f');


		if(uss_data_now[1] > 40 && uss_data_now[2] > 40){
			if(obst==3){
				if(uss_data_now[1] < 100 && uss_data_now[2] < 100){
				
					if(uss_data_now[0] > 60){
						kobeya_state=2;
						state=KOBEYA;
					}
				}
				flag_reset();
				return;
			}
			if(obst==4){
				conor_detect(&c,&val,&f_val);
				fprintf(fp,"/////conor:c = %c,val = %d/////\n",c,val);
				fclose_open('f');
				rotary_center=val;
				rotary_distance=f_val;
				rotary_center=-rotary_center;
				state=ROTARY;
				flag_reset();
				return;
			}
		}else if(uss_data_now[2] > 40){
			if(obst==4){
				conor_detect(&c,&val,&f_val);
				fprintf(fp,"/////conor:c = %c,val = %d/////\n",c,val);
				fclose_open('f');
				if(c=='r'){
					rotary_center=val;
					rotary_center=-rotary_center;
					rotary_distance=f_val;
					state=ROTARY;
					flag_reset();
					return;
				}
			}
			if(uss_data_now[0] > 60){
				if(obst==3){
					if(uss_data_now[1] < 200){
						kobeya_state=1;
						state=KOBEYA;
					}
				}
				flag_reset();
				return;
			}else{
				if(uss_data_now[0] > 25 && uss_data_now[0] < 40){
					state=R_TURN;
					//if(uss_data_now[0] > 50)state=STRAIGHT;
					if(uss_data_now[1] > 40)state=STRAIGHT;
					state_tmp=STRAIGHT;
					flag_reset();
					return;
				}else if(uss_data_now[0] > 40){
					//straight_time=0;
					state=STRAIGHT;
					//timer_straight_speed=30;
				}else if(uss_data_now[0] < 25 &&uss_data_now[0] < 30){
					straight_time=1;
					state=TIMER_STRAIGHT;
					timer_straight_speed=-30;
				}
			}
		}else if(uss_data_now[1] > 40){
			if(obst==4){
				conor_detect(&c,&val,&f_val);
				fprintf(fp,"/////conor:c = %c,val = %d/////\n",c,val);
				fclose_open('f');
				if(c=='r'){
					rotary_center=val;
					rotary_center=-rotary_center;
					rotary_distance=f_val;
					state=ROTARY;
					flag_reset();
					return;
				}
			}
			if(uss_data_now[0] > 60){
				if(obst==3){
					if(uss_data_now[2] < 200){
						kobeya_state=3;
						state=KOBEYA;
					}
				}
				flag_reset();
				return;
			}else{
				if(uss_data_now[0] > 25 && uss_data_now[0] < 40){
					state=L_TURN;
					//if(uss_data_now[0] > 50)state=STRAIGHT;
					if(uss_data_now[2] > 40)state=STRAIGHT;
					state_tmp=STRAIGHT;
					flag_reset();
					return;
				}else if(uss_data_now[0] > 40){
					//straight_time=0;
					state=STRAIGHT;
					//timer_straight_speed=30;
				}else if(uss_data_now[0] < 25 &&uss_data_now[0] < 30){
					straight_time=1;
					state=TIMER_STRAIGHT;
					timer_straight_speed=-30;
				}
			}
		}
	}
	state=STRAIGHT;
	return;
}


void flag_reset(void){
	r_uss_wall_flag=1;
	l_uss_wall_flag=1;
	f_ts_flag=0;
	r_ts_flag=0;
	l_ts_flag=0;
	r_ws_flag=0;
	const_flag=0;
	time_end_flag=0;
	motor_restart_flag=0;
	uss_exit_flag=0;
	timer_exit_flag=0;
	ts_exit_flag=0;
}
