/*
 * kobeya_left_control.c
 *
 *  Created on: 2013/01/11
 *      Author: d09101
 */


#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <errno.h>
#include "func_extern.h"
#include "motor.h"
#include "control.h"

#include "uss_control.h"
#include "kobeya.h"



extern int l_uss_wall_flag;
extern int f_ts_flag;
extern int const_flag;

extern int kobeya_state;
extern int kobeya_exit_flag;

extern int step;

extern int r1_def,l1_def,l2_def;
extern int uss_use;

extern time_t start_time;

extern FILE *fp;
extern char word[100];

void kobeya_left_control(void){
	int uss_2=0;
	int kobeya_param[5],l2_uss,ret=0;
	switch(step){
		case 1:
			fprintf(fp,"kobeya_state = %d",kobeya_state);
			fprintf(fp,"/////kobeya_step1/////\n");
			fclose_open('f');
			time( &start_time );
			if(kobeya_state==2||kobeya_state==3){
				kobeya_param[0]=KOBEYA_STEP1_VAL;
				kobeya_param[1]=KOBEYA_STEP1_SPEED;
				kobeya_param[4]=5;
				pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
				pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
				pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
				//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(motor_task2, NULL);
				pthread_join(irs_ts_ws_task, NULL);
				pthread_join(timer_task, NULL);
				if(const_flag==1)step=2;
			} else {
				ret=correction();
				if(const_flag==1||ret==-1)step=2;
			}
			break;
		case 2:
			fprintf(fp,"/////kobeya_step2/////\n");
			fclose_open('f');
			if(kobeya_state==2||kobeya_state==3){
				kobeya_param[0]=KOBEYA_STEP2_VAL;
				kobeya_param[1]=1;
				kobeya_param[4]=0;
				pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
				pthread_create(&motor_task1, &attr_motor1,mk_left_turn,kobeya_param);
				pthread_join(motor_task1, NULL);
				pthread_join(irs_ts_ws_task, NULL);
				if(const_flag==1)step=3;
			} else step=3;
			break;
		case 3:
			fprintf(fp,"/////kobeya_step3/////\n");
			fclose_open('f');
			time( &start_time );
			if(kobeya_state==2||kobeya_state==3){
				kobeya_param[0]=KOBEYA_STEP3_VAL;
				kobeya_param[1]=KOBEYA_STEP3_SPEED;
				kobeya_param[4]=0;
				pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
				pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
				pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
				//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(motor_task2, NULL);
				pthread_join(irs_ts_ws_task, NULL);
				pthread_join(timer_task, NULL);
				if(const_flag==1)step=4;
			} else step=4;
			break;
		case 4:
			ret=correction();
			if(const_flag==1||ret==-1)step=5;
			break;
		case 5:
			fprintf(fp,"/////kobeya_step4/////\n");
			fclose_open('f');
			//talk_stop();
			sprintf((char*)word,"de'guchiha/do'ko?");
			talk(word);
			l1_def=L1_DEF;l2_def=L2_DEF;
			uss_use=20;
			kobeya_param[0]=KOBEYA_STEP4_SPEED;
			kobeya_param[4]=0;
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
			pthread_create(&uss_task,&attr_uss,uss_thread,NULL);
			pthread_create(&motor_task1, &attr_motor1,original_straight_thread,kobeya_param);
			//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
			pthread_join(motor_task1, NULL);
			//pthread_join(motor_task2, NULL);
			pthread_join(uss_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			if(f_ts_flag==1)step=6;
			if(l_uss_wall_flag==0){
				//talk_stop();
				sprintf((char*)word,"de'guchi/hakke'n");
				talk(word);
				step=10;
			}
			if(kobeya_exit_flag==1)step=0;
			break;
		case 6:
			fprintf(fp,"/////kobeya_step5/////\n");
			fclose_open('f');
			time( &start_time );
			kobeya_param[0]=KOBEYA_STEP5_VAL;
			kobeya_param[1]=KOBEYA_STEP5_SPEED;
			kobeya_param[4]=5;
			pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
			pthread_join(motor_task1, NULL);
			//pthread_join(motor_task2, NULL);
			pthread_join(timer_task, NULL);
			if(const_flag==1)step=7;
			break;
		case 7:
			//talk_stop();
			sprintf((char*)word,"seitaihoseichu'u");
			talk(word);
			ret=correction();
			if(const_flag==1||ret==-1)step=8;
			break;
		case 8:
			fprintf(fp,"/////kobeya_step6/////\n");
			fclose_open('f');
			//talk_stop();
			sprintf((char*)word,"mawari'ma-su.");
			talk(word);
			time( &start_time );
			kobeya_param[0]=KOBEYA_STEP6_ANGLE;
			kobeya_param[1]=KOBEYA_STEP6_SPEED;
			kobeya_param[4]=8;
			pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
			pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,kobeya_param);
			//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
			pthread_join(motor_task1, NULL);
			//pthread_join(motor_task2, NULL);
			pthread_join(timer_task, NULL);
			if(const_flag==1)step=9;
			break;
		case 9:
			ret=correction();
			if(const_flag==1||ret==-1)step=5;
			break;
		case 10:
			fprintf(fp,"/////kobeya_step9/////\n");
			fclose_open('f');
			kobeya_param[0]=KOBEYA_STEP7_VAL;
			kobeya_param[1]=KOBEYA_STEP7_SPEED;
			kobeya_param[4]=5;
			pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
			pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
			pthread_create(&motor_task1, &attr_motor1,const_straight_thread,kobeya_param);
			//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
			pthread_join(motor_task1, NULL);
			//pthread_join(motor_task2, NULL);
			pthread_join(timer_task, NULL);
			pthread_join(irs_ts_ws_task,NULL);
			if(const_flag==1)step=0;
			break;
	}
}
