/*
 * correct_test.c
 *
 *  Created on: 2013/01/20
 *      Author: d09101
 */


#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>
#include <errno.h>
#include "func_extern.h"
#include "motor.h"
#include "control.h"

int r_uss_wall_flag;
int l_uss_wall_flag;
int uss_pid;
int uss_use;

int f_ts_flag;
int r_ts_flag;
int l_ts_flag;
int r_ws_flag;

float sp_time;
int time_end_flag;
int kobeya_exit_flag;

FILE *fp;

time_t start_time;

int main(void){

	char c;


	pthread_attr_init (&attr_motor1);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_motor1, SCHED_RR);
	pthread_attr_setschedparam (&attr_motor1, &sched_param);

	pthread_attr_init (&attr_motor2);
	sched_param.sched_priority = 21;
	pthread_attr_setschedpolicy(&attr_motor2, SCHED_RR);
	pthread_attr_setschedparam (&attr_motor2, &sched_param);

	printf("opening device...\n");
	fd1 = open(M_PORT_L, O_RDWR);
	if(fd1 < 0){
		if(errno == 3) printf("no such file\n");
		else if(errno == 13) printf("permission\n");
		else printf("other\n");
		fprintf(stderr, "fd1 open error\n");
		exit(-1);
	}
	fd2 = open(M_PORT_R, O_RDWR);
	if(fd2 < 0){
		fprintf(stderr, "fd2 open error\n");
		close(fd1);
		exit(-1);
	}
	printf("end\n");

	printf("starting...\n");
	fp=fopen("../output/out.txt","w");

	if(correction() == -1){
		printf("cannot correction\n");
	}

	printf("end\n");

	printf("closing device...\n");
	close(fd1);
	close(fd2);
	printf("end\n");
	printf("Finish!!\n");

	return 0;
}


void fclose_open(char c){
	switch(c){
		case 'f':
			fclose(fp);
			fp=fopen("../output/out.txt","a");
			break;
	}
}
